Subject: RE: two-week review: registering formal "rdns" NID

From: "Ing-Wher (Helen) Chen" <[email-masked]>
Date: Wed, 9 Mar 2016 16:28:36 +0000

Hello again,

I've taken Dale's advice to restrict the rdns URNs to be entirely lowercase
letters (by eliminating uppercase letters in <URN chars>), to bypass the need for
case-insensitive and case-sensitive comparison for lexical equivalence.
The latest version is -05.

URL:            https://www.ietf.org/internet-drafts/draft-chen-rdns-urn-05.txt
Status:         https://datatracker.ietf.org/doc/draft-chen-rdns-urn/
Htmlized:       https://tools.ietf.org/html/draft-chen-rdns-urn-05
Diff:           https://www.ietf.org/rfcdiff?url2=draft-chen-rdns-urn-05

The diff between the latest version -05 and the previous version I posted 
on this list, -03 (not -04), is here:

<https://www.ietf.org/rfcdiff?url1=https://www.ietf.org/archive/id/draft-chen-rdns-urn-03.txt&url2=https://www.ietf.org/id/draft-chen-rdns-urn-05.txt>

Thanks,
Helen

> -----Original Message-----
> From: Ing-Wher (Helen) Chen
> Sent: Monday, February 22, 2016 5:38 PM
> To: 'Martin J. Dürst' <[email-masked]>; Dale R. Worley
> <[email-masked]>
> Cc: [email-masked]
> Subject: RE: two-week review: registering formal "rdns" NID
> 
> Hi Martin and Dale,
> 
> Thanks for pointing out that "urn:rdns" should be case insensitive.
> I've updated the section on "Rules for Lexical Equivalent".
> 
> URL:            https://www.ietf.org/internet-drafts/draft-chen-rdns-urn-03.txt
> Status:         https://datatracker.ietf.org/doc/draft-chen-rdns-urn/
> Htmlized:       https://tools.ietf.org/html/draft-chen-rdns-urn-03
> Diff:           https://www.ietf.org/rfcdiff?url2=draft-chen-rdns-urn-03
> 
> Thanks,
> Helen
> 
> > -----Original Message-----
> > From: Martin J. Dürst [mailto:[email-masked]]
> > Sent: Friday, February 19, 2016 11:09 PM
> > To: Dale R. Worley <[email-masked]>; Ing-Wher (Helen) Chen
> > <[email-masked]>
> > Cc: [email-masked]
> > Subject: Re: two-week review: registering formal "rdns" NID
> >
> > Hello Dale, Helen, others,
> >
> > Indeed as Dale says, the "urn" and "rdns" components are
> > case-insensitive, and a namespace registration cannot change that.
> >
> > Regards,   Martin.
> >
> > On 2016/02/20 05:41, Dale R. Worley wrote:
> > > Comments on draft-chen-rdns-urn-02:
> > >
> > > "Ing-Wher (Helen) Chen" <[email-masked]> writes:
> > >>> Comments on draft-chen-rdns-urn-00:
> > >>
> > >> [Helen]  Just a note that at the time that I submitted to
> > >>                 [email-masked] for review, the latest version was -01.
> > >
> > > I should have noticed that!
> > >
> > > I think your changes take care of the problems that I've noticed.
> > >
> > >>> The rule for lexical equivalence can't be implemented because
> > >>> there is no algorithm for parsing an "rdns" URN into <reverse-dns>
> > >>> and <dss>, and the lexical equivalence rule specifies that
> > >>> <reverse-dns> is case-insensitive and <dss> is case-sensitive (as
> > >>> far as I can tell; you
> > should update the wording).
> > >>
> > >> [Helen]  I updated the section on "Rules for Lexical Equivalence".
> > >> On
> > second
> > >>                 thought, because "rdns" URNs are meant to be XML
> > >>                 namespaces of enterprise YANG modules, I think the
> > >>                 rules for lexical equivalence for "rdns" URNs should be
> > >>                 as defined for those of XML namespaces.
> > >
> > > There might be a problem, as RFC 2141 prescribes that "urn" and the
> > > NID
> > > ("rdns") are case-insensitive, whereas the draft prescribes that all
> > > of the URN is to be compared case-sensitively.  Looking at RFC 3406,
> > > the definition of the NID registration template, Appendix B.1 gives
> > > an
> > > example:
> > >
> > >     Rules for Lexical Equivalence:
> > >
> > >        FQDNs are case-insensitive.  Thus, the portion of the URN
> > >
> > >                    urn:<assigned number>:<FQDN>:
> > >
> > >        is case-insensitive for matches.  The remainder of the identifier
> > >        must be considered case-sensitive.
> > >
> > > The syntax for rdns URNs is
> > >
> > >         "rdns" URN    ::= urn:rdns:<reverse-dns>:<dss>
> > >         <reverse-dns> ::= registered domain name in reverse, each label
> > >                           separated by a colon (":")
> > >         <dss>         ::= 1*<URN chars>
> > >
> > > I think we are constrained to require (for URN comparison) that "urn"
> > > and "rdns" be case-insensitive, whereas you can specify whatever
> > > rule you want for the reverse-dns and dss parts.
> > >
> > > But perhaps other people on this list have more knowledge of how
> > > this issue has been handled for other URN namespaces.
> > >
> > > Dale
> > >
> > > .
> > >

---

From: [email-masked] (Dale R. Worley)
Date: Fri, 18 Mar 2016 16:50:08 -0400

This version clarifies and simplifies many issues and I think it is
nearly ready for publication.  However, there are two issues:

       <rdns-trans>     ::= <lower> | <number> | <others> | <reserved>

Comparing with RFC 2141, "<others>" should be "<other>".

The alternative "<reserved>" should be removed.  In RFC 2141, I see:

   <trans>       ::= <upper> | <lower> | <number> | <other> | <reserved>

However the final alternative in that production is not to be used in
practice.  Its expansion is:

   <reserved>    ::= '%" | "/" | "?" | "#"

However, the immediately following text in 2141 states that "%" is to be
used only to introduce %-escapes (which this draft does in the
production "<rdns-URN-char>").  And the remaining three characters are
described as 

   RFC 1630 [2] reserves the characters "/", "?", and "#" for particular
   purposes. The URN-WG has not yet debated the applicability and
   precise semantics of those purposes as applied to URNs. Therefore,
   these characters are RESERVED for future developments.  Namespace
   developers SHOULD NOT use these characters in unencoded form, but
   rather use the appropriate %-encoding for each character.

Dale

---

From: "Ing-Wher (Helen) Chen" <[email-masked]>
Date: Fri, 18 Mar 2016 21:21:06 +0000

Hi Dale,

Thanks very much for the corrections.  I updated to version -06.

URL:            https://www.ietf.org/internet-drafts/draft-chen-rdns-urn-06.txt
Status:         https://datatracker.ietf.org/doc/draft-chen-rdns-urn/
Htmlized:       https://tools.ietf.org/html/draft-chen-rdns-urn-06
Diff:           https://www.ietf.org/rfcdiff?url2=draft-chen-rdns-urn-06

Thanks,
Helen

> From: Dale R. Worley [mailto:[email-masked]]
> Sent: Friday, March 18, 2016 4:50 PM
> To: Ing-Wher (Helen) Chen <[email-masked]>
> Subject: draft-chen-rdns-urn-05 (Re: two-week review: registering formal
> "rdns" NID)
> 
> This version clarifies and simplifies many issues and I think it is nearly ready for
> publication.  However, there are two issues:
> 
> However the final alternative in that production is not to be used in practice.  Its
> expansion is:
> 
> However, the immediately following text in 2141 states that "%" is to be used
> only to introduce %-escapes (which this draft does in the production "<rdns-
> URN-char>").  And the remaining three characters are described as
>